/* 
        MaslXImage.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	original Ak5XImage.h written by Daisuke Iizuka
        Copyright (c)1997 Daisuke Iizuka(iizuka@masada.t.u-tokyo.ac.jp)

	modified into MaslXImage by Yamahata for xmm
*/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef MITSHM
#include <X11/extensions/XShm.h>
#endif //MISTHM

#ifndef masl_ximage_h
#define masl_ximage_h
////////////////////////////////////////////////////////////////////////
// ݥ١饹
////////////////////////////////////////////////////////////////////////
class MaslXImage
{
protected:
  Display* display;
  Visual* visual;
  const unsigned int depth;
  const int width;
  const int height;

  XImage* ximage;
  char* pImageData;

  MaslXImage (Display* maslDisplay,Visual* maslVisual,
	      unsigned int maslDepth,int maslWidth,int maslHeight):
    display (maslDisplay),visual (maslVisual),depth (maslDepth),
    width (maslWidth),height (maslHeight),ximage (NULL),pImageData (NULL)
    {/* do nothing */;};
  
public:
  virtual ~MaslXImage (){/* do nothing */;};
  virtual void XPutImage(Drawable drawable, GC gc,
			 int srcX, int srcY, int destX, int destY,
			 unsigned int width,unsigned int height)=0;
  char* getImagePointer (){return pImageData;};
};


////////////////////////////////////////////////////////////////////////
// ̤ XImage Ѥ饹
////////////////////////////////////////////////////////////////////////
class MaslXNormalImage : public MaslXImage
{
private:

public:
  MaslXNormalImage(Display* maslDisplay,Visual* maslVisual,
		   unsigned int depth,int maslWidth,int maslHeight);
  ~MaslXNormalImage();
  void XPutImage(Drawable drawable,GC gc,
		 int snrcX,int srcY,int destX,int destY,
		 unsigned int width,unsigned int height);
};


#ifdef MITSHM
////////////////////////////////////////////////////////////////////////
// MIT-SHM Ѥ饹
////////////////////////////////////////////////////////////////////////
class MaslXShmImage : public MaslXImage
{
private:
  XShmSegmentInfo shminfo;
  int             iXShmAttach;

public:
  MaslXShmImage (Display* maslDisplay,Visual* maslVisual,
		 unsigned int maslDepth,int maslWidth,int maslHeight);
  ~MaslXShmImage ();
  void XPutImage(Drawable drawable,GC gc,
		 int srcX,int srcY,int destX,int destY,
		 unsigned int width,unsigned int height);
};
#endif //MITSHM
#endif masl_ximage_h
