/* 
        Mms.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/

#include <stdio.h>
#include <iostream.h>
#include <ctype.h>
#include <sys/time.h>
//#include <time.h>
#include <signal.h>
#include <errno.h>

//XϢ
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#ifdef DEBUG_MODE
#include <curses.h>
#endif//DEBUG_MODE

#ifdef RENICE
#include <sys/resource.h>
#include <unistd.h>
#endif //RENICE

#include "MmsConst.h"
#include "MmsScenario.h"
#include "MmsWindow.h"
#include "Nak.h"
#include "MmsPalette.h"
#include "Pcm.h"
#include "DebugMode.h"

#ifndef mms_h
#define mms_h

//#define MAXLOOP 64//롼פΥͥȲǽ
#define MAXLOOP 2048//롼פΥͥȲǽ
#define MAXCALL 64//֥롼󥳡ΥͥȲǽ
#define MAXPCMCH 4//PCMͥκ

class Mms
{
#ifdef TEST_NAK
public:
#else  
private:
#endif
  ////////////////////header줫㴳ѹɬ
  //masl fileheader
  const int argc;////command line option for scenario
  char** const argv;//command line option for scenario

  const int mmsOptionArgc;//number fo command line option for MMS scenario
  const char** const mmsOptionArgv;//command line option for MMS scenario
  MmsScenario* scenario;
  int hz;//=60*100;//timer couter®(1ô֤hz/100ȿʤࡣ)
  //default60*100
  void waitBeforePlaying (int docwait);
  //ǡmethodǾdocwait secondԤ

  /////////////////////////////////////////////////////////////Xط
  Display* display;//ɽdisplay
  int screen;//screenֹ
  Visual* visual;//visual
  int depth;//depth of color
  Window window;//window
  Colormap colormap;//color map
  GC gc;//graphic context
  unsigned long basePixel;
  unsigned long planeMask[DEPTH_OF_NAK];
  unsigned long palette2Pixel [NUM_OF_COLORS];
  //=paletteͤpixelͤ٤ʪ
  MmsWindow* mmsWindow;

  //void prepareXServer ();//X server³¾classν򤹤롣
  void allocColors ();//XογݤȤ˴ϢԤʤ
  
  ////////////////////////////////////////////////ޤdataξ
  Nak* pNak[MAXNAK];//object
  int numberOfNak;//dataο
  MmsPalette* pMmsPalette[MAXPAL];//palette object
  int numberOfMmsPalette;//paletteο
  Pcm* pPcm[MAXPCM];//PCM object
  int numberOfPcm;//PCM dataο
  
  ////////////////////////////////////////////////////////////MMSΰ٤ѿ
  //char* scenarioPointer;//ߤscenarioΰ֤ؤpointer
  //char* beginPoint;//Υޥΰκǽؤpointer
  //(ٷޤлؤ֤Ѳʤ)
  const char* pt;//ߤscenarioΰ֤ؤpointer()
  
  const char* callStack[MAXCALL];//֥롼󥳡
  short numberOfCall;//call stackο

  short numberOfLoopCounter[MAXLOOP];//loop counter
  short numberOfLoop;//loopΥͥȿ

  int intVar[MAXVAR];//ѿ
  GraphicMode graphicMode;
  //={320*200⡼,640*240⡼,320*400⡼,640*480⡼}
  int nNak;//ֺǸŸnakֹ
  int nPalette;//ߤpaletteֹ

//vramʪpaletteͤǼ
//Ǥclass MMSWindow˰ϤǤѴɽ
  unsigned char virtualVram[VIRTUAL_VRAM_LENGTH];

  ///////////////////////////////////////////////////////timerϢ
  timeval startTime;//ϻФƤ
  timeval nowTime;//ּ(timer count)
  int getTimerCount ();//timerȤ֤
  long timeCntForWait;//timer countԤ򤷤ƤcounterޤԤġ
  Bool isTimerWaiting;//timer countԤ򤷤Ƥ뤫
                      //=True:Ƥ =FalseƤʤ
  Bool isDispWaiting;//disp̿᤬äƤ
  //=True:äƤ =False:äƤʤ
  Bool isLate;//Ƥ뤫
  //=True:Ƥ =False:Ƥʤ

#if 0
  //////////////////////////////////////////Ÿɬס
  int aheadlyExtractedNakNumber;
  //ŸƤֹ档
  //=-1λŸƤʤ(٤ƤӽФƤʤ)
  NakAhead* nakAhead;//Ÿ٤ʪ
#endif

   ///////////////////////////////////////////////////////////PCMΰ٤ʪ
  char isAudioWriting;//write٤PCM dataͭ뤫
  //(ʤBoolͤ8ޤǤʤ餽줾bitɽ)
  char isAudioWaiting;//PCMκλԤ򤷤Ƥ뤫

  ////////////////////////////////////////////////////////////X Event
  XEvent event;//Xevent
  static const long maslEventMask;//=KeyPressMask|ExposureMask|
  //ButtonPressMask|ButtonReleaseMask|Button1MotionMask;//event mask
  //ϻŪǽ䤹Ϥäɬ
  int isKeyPressed (const KeySym keysym,const char keyVector[32]);
  //keyƤ뤫ݤȽ򤹤롣
  //keycodeбkeyƤС1֤
  //Ǥʤ0֤
  
#ifdef DEBUG_MODE
  /////////////////////////////////////debug mode
#include "MmsDebugMode.h"
  DebugMode* debugMode;
#endif//DEBUG_MODE

  ///////////////////////////////////////xmaslФoptionν
  XMMS_OPTION xmmsOption;
  void setXMmsOption (XMMS_OPTION xmmsOption);

  ////////////////////////////////////////////////file load & 
  Bool loadNak (MaslInputStream& maslIs);
  Bool loadPkn (MaslInputStream& maslIs);
  Bool loadAll (const char* const filename);

  ////////////////////////////////////////////////////////scenario
  Bool isOptionSpecified (char c);
  Bool isOptionSpecified2 (const char*& opts);
  int getOptionValue (char c);
  int searchnum ();
  int searchnum (const char* pt);
  int getValue ();
  Bool isValue () const 
    {return isdigit (*pt)||*pt=='R'||*pt=='@'||*pt=='K'||*pt=='O'||*pt=='P'||
       *pt=='F';};
  Bool searchNextCommand ();
  Bool joukenHantei ();

public:
  Mms (Display* xmmDisplay,
       const int __argc,char** const __argv,
       const char* const filename,
       XMMS_OPTION xmmsOptoin);
  ~Mms ();
  //ʲmaslκɬפmethod
  void preparePlay ();//ν
  //ѿaudio deviceμ
  Bool play ();//play loopXEvent queˤƤɬפͭ?
  void afterPlay ();//playˤƤǤ
  //audio deviceclose򤹤
  void updateWindow (){mmsWindow->updateWindow (virtualVram);};
  ///////////////////////////////////////access method
  int getNumberOfNak () const {return numberOfNak;};
  int getLastDrawedNakNumber () const {return nNak;};
  int getNumberOfMmsPalette () const {return numberOfMmsPalette;};
  int getCurrentMmsPaletteNumber () const {return nPalette;};
  int getNumberOfPcm () const {return numberOfPcm;};
/*
  int getAheadlyExtractedCellNumber () const
    {return aheadlyExtractedCellNumber;};
*/
  GraphicMode getGraphicMode () const {return graphicMode;};
  int getTimeCounter () const {return (int)hz;};
  long getStartTimeSec () const {return startTime.tv_sec;};
  long getStartTimeUsec () const {return startTime.tv_usec;};
  long getTimeCntForWait () const {return timeCntForWait;};
  Bool getIsTimerWaiting () const {return isTimerWaiting;};
  Bool getIsDispWaiting () const {return isDispWaiting;};
  Bool getIsAudioWriting () const {return isAudioWriting;};
  Bool getIsAudioWaiting () const {return isAudioWaiting;};

  //////////////////////////////////////////////////////mmsΰ٤command
private:
  
  struct VALUE_COMMAND
  {
    char value;
    int (*getValue) (Mms& mms);
  };

  static const VALUE_COMMAND valueTable[];
  static const int NUMBER_VALUE;

public://privateˤΤ
  ////////////////////////////////////˻Ȥͤ٤ʪ
  static int getValueDigit (Mms& mms);
  static int getValueRand (Mms& mms);
  static int getValueVar (Mms& mms);
  static int getValueKey (Mms& mms);
  static int getValueOption (Mms& mms);
  static int getValueTimer (Mms& mms);
  static int getValuePCMState (Mms& mms);
  static int getValueFState (Mms& mms);

private:
  struct MMS_COMMAND
  {
    char* command;
    void (*executeCommand) (Mms& mms);
  };
  static const Mms::MMS_COMMAND commandTable[];
  static const int numberOfCommand;
public://privateˤΤ
  /////////////////////////////////////////////////////
  static void cmdLeftBracket (Mms& mms);
  static void cmdRightBracket (Mms& mms);
  static void cmdLeftBrace (Mms& mms);
  static void cmdRightBrace (Mms& mms);
  static void cmdLabel (Mms& mms);
  static void cmdJump (Mms& mms);
  static void cmdCall (Mms& mms);
  static void cmdRet (Mms& mms);
  static void cmdDelret (Mms& mms);
  static void cmdMmsload (Mms& mms);
  static void cmdMmscall (Mms& mms);
  static void cmdMmsret (Mms& mms);
  /////////////////////////////////////////////////////math
  static void cmdLet (Mms& mms);
  static void cmdPlus (Mms& mms);
  static void cmdMinus (Mms& mms);
  static void cmdTimes (Mms& mms);
  static void cmdDivide (Mms& mms);
  static void cmdModulo (Mms& mms);
  static void cmdAnd (Mms& mms);
  static void cmdOr (Mms& mms);
  static void cmdXor (Mms& mms);
  static void cmdSet (Mms& mms);
  ////////////////////////////////////////////////////////grahpics
  static void cmdGmode (Mms& mms);/////////window
  static void cmdWsize (Mms& mms);
  static void cmdWmove (Mms& mms);
  static void cmdD (Mms& mms);
  static void cmdM (Mms& mms);
  static void cmdOrm (Mms& mms);
  static void cmdZoom (Mms& mms);
  static void cmdBox (Mms& mms);
  static void cmdPset (Mms& mms);
  static void cmdPoint (Mms& mms);
  static void cmdPsetw (Mms& mms);
  static void cmdPointw (Mms& mms);
  static void cmdPal (Mms& mms);////////////palette
  static void cmdDpal (Mms& mms);
  static void cmdPalNum (Mms& mms);
  static void cmdMove (Mms& mms);
  static void cmdTone (Mms& mms);
  static void cmdPtone (Mms& mms);
  static void cmdDisp (Mms& mms);///////////draw
  static void cmdCdisp (Mms& mms);
  /////////////////////////////////////////////////////////////pcm
  static void cmdPcm (Mms& mms);
  static void cmdPcml (Mms& mms);
  static void cmdPch (Mms& mms);
  static void cmdPchl (Mms& mms);
  static void cmdPwt (Mms& mms);
  static void cmdPst (Mms& mms);
  static void cmdRate (Mms& mms);
  static void cmdCount (Mms& mms);
  ///////////////////////////////////////////////////timer counter
  static void cmdTc (Mms& mms);
  static void cmdT (Mms& mms);
  ///////////////////////////////////////////////////////etc
  static void cmdReadpara (Mms& mms);
  static void cmdGetpara (Mms& mms);
  static void cmdComment (Mms& mms);
  static void cmdColon (Mms& mms);
  //static void extractNakAhead (Mms& mms);
};
#endif //mms_h
