/* 
        MmsPalette.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
#include "MmsPalette.h"

Display* MmsPalette::display;
Colormap MmsPalette::colormap;
unsigned long MmsPalette::palette2Pixel[NUM_OF_COLORS];
MmsPalette::PALETTE MmsPalette::paletteOfNow[NUM_OF_PALETTES][NUM_OF_COLORS];

MmsPalette::MmsPalette (MaslInputStream& maslIs)
{
  int commentSize=maslIs.get16 ();
  offset=maslIs.get16 ();
  //cerr << "offset=" << offset << endl;
  offset/=3;////1paletteˤĤr,g,b3bytա
  size=maslIs.get16 ();
  maslIs.seekg (commentSize,ios::cur);//ΰcomment

  unsigned char* buffer=new unsigned char[size];//dataɤ߹Ѥbuffer
  maslIs.read (buffer,size);//dataɤ߹
  size/=3;//paletteθĿˤʤ롣(1paletteˤĤr,g,b3byte)
  palette=new PALETTE[size];
  int c=0;
  for (int i=0;i<size;i++)
    {//palette
      palette[i].r=buffer[c];
      c++;
      palette[i].g=buffer[c];
      c++;
      palette[i].b=buffer[c];
      c++;
    }
  delete[] buffer;

#if 0
#ifdef DEBUG
  cerr << "offset=" << offset << endl;
  cerr << "size=" << size << endl;
  for (int i=0;i<size;i++)
    {
      cerr << i << "-th palette (r,g,b)=("
	   << (int) (palette[i].r) << ","
	   << (int) (palette[i].g) << ","
	   << (int) (palette[i].b) << ")"
	   << endl;
    }
#endif
#endif
}

MmsPalette::~MmsPalette ()
{
  delete[] palette;
}

void MmsPalette::printData () const
{
  cout << "offset=" << offset << endl;
  cout << "size=" << size << endl;
  for (int i=0;i<size;i++)
    {
      cerr << i << "-th palette (r,g,b)=("
	   << (int) (palette[i].r) << ","
	   << (int) (palette[i].g) << ","
	   << (int) (palette[i].b) << ")"
	   << endl;
    }
}

void MmsPalette::prepareMmsPalette (Display* const maslDisplay,
				    const Colormap maslColormap,
				    const unsigned long
				    mmsPalette2Pixel[NUM_OF_COLORS])
{
  display=maslDisplay;
  colormap=maslColormap;
  for (int i=0;i<NUM_OF_COLORS;i++)
    palette2Pixel[i]=mmsPalette2Pixel[i];

  for (int j=0;j<NUM_OF_PALETTES;j++)
    {
      for (int i=0;i<NUM_OF_COLORS;i++)
	{
	  paletteOfNow[j][i].r=0;
	  paletteOfNow[j][i].g=0;
	  paletteOfNow[j][i].b=0;
	}
    }
}

void MmsPalette::setPalette (const int bufferNumber=0)
{//buffetNumber bufferpaletteȤϤɤ

  //check
  assert (bufferNumber==0||bufferNumber==1);
  assert (offset+size<=NUM_OF_COLORS);
  
  for (int i=0;i<size;i++)
    {
      /////////////////ꤵƤpaletteФƤ
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].r=palette[i].r;
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].g=palette[i].g;
      paletteOfNow[bufferNumber][abs(i+offset)%NUM_OF_COLORS].b=palette[i].b;

    }

  if (bufferNumber==0)
    {
      //
      XColor xcolors[size];
      for (int i=0;i<size;i++)
	{
	  //xcolors[i].pixel=palette2Pixel[(i+offset) % NUM_OF_COLORS];
	  xcolors[i].pixel=palette2Pixel[abs(i+offset) % NUM_OF_COLORS];
	  xcolors[i].flags=DoRed|DoGreen|DoBlue;
	  //0<=r,g,b<256Ǥꡢ
	  //XColorγʬͤ0-65535Ǥä
	  //65536/256=256
	  xcolors[i].red  =(palette[i].r << 8);
	  xcolors[i].green=(palette[i].g << 8);
	  xcolors[i].blue =(palette[i].b << 8);
	}
      XStoreColors (display,colormap,xcolors,size);
    }
}

void MmsPalette::setPalette (const int paletteNumber,
			     const int r,const int g,const int b,
			     const int bufferNumber=0)
{
  ////////check
  assert (0<=paletteNumber);
  assert (paletteNumber<NUM_OF_COLORS);
  assert (0<=r);
  assert (r<256);
  assert (0<=g);
  assert (g<256);
  assert (0<=b);
  assert (b<256);
  assert (bufferNumber==0||bufferNumber==1);
  
  /////////////////ꤵƤpaletteФƤ
  paletteOfNow[bufferNumber][paletteNumber].r=r;
  paletteOfNow[bufferNumber][paletteNumber].g=g;
  paletteOfNow[bufferNumber][paletteNumber].b=b;
/*
#ifdef DEBUG
  cerr << "paletteNumber=" << paletteNumber << ":"
       << "r=" << r << ",g=" << g << ",b=" << b << endl;
#endif
*/
  if (bufferNumber==0)
    {
      XColor xcolor;
      xcolor.pixel=palette2Pixel[paletteNumber];
      xcolor.flags=DoRed|DoGreen|DoBlue;
      xcolor.red  =(r << 8);//0<=r,g,b<256Ǥꡢ
      xcolor.green=(g << 8);//XColorγʬͤ0-65535Ǥä
      xcolor.blue =(b << 8);//65536/256=256
      /*
	#ifdef DEBUG
	cerr << "red=" << xcolor.red 
	<< ",blue=" << xcolor.blue 
	<< ",green=" << xcolor.green << endl;
	#endif
	*/
      XStoreColor (display,colormap,&xcolor);
    }
}

void MmsPalette::setPTone (const int contrast,const int ratio,
			   const int startColorNumber,
			   const int lastColorNumber)
{
  const int numberOfColors=lastColorNumber-startColorNumber+1;
  XColor xcolors[numberOfColors];
  for (int i=0;i<numberOfColors;i++)
    {
      xcolors[i].pixel=palette2Pixel[i+startColorNumber];
      xcolors[i].flags=DoRed|DoGreen|DoBlue;

#if 0      
      const unsigned long r1=paletteOfNow[0][i+startColorNumber].r;
      const unsigned long g1=paletteOfNow[0][i+startColorNumber].g;
      const unsigned long b1=paletteOfNow[0][i+startColorNumber].b;
      const unsigned long r2=paletteOfNow[1][i+startColorNumber].r;
      const unsigned long g2=paletteOfNow[1][i+startColorNumber].g;
      const unsigned long b2=paletteOfNow[1][i+startColorNumber].b;

      paletteOfNow[0][i+startColorNumber].r=(r1*(256-ratio)+r2*ratio)/256;
      paletteOfNow[0][i+startColorNumber].g=(g1*(256-ratio)+g2*ratio)/256;
      paletteOfNow[0][i+startColorNumber].b=(b1*(256-ratio)+b2*ratio)/256;

      paletteOfNow[1][i+startColorNumber].r=(r1*ratio+r2*(256-ratio))/256;
      paletteOfNow[1][i+startColorNumber].g=(g1*ratio+g2*(256-ratio))/256;
      paletteOfNow[1][i+startColorNumber].b=(b1*ratio+b2*(256-ratio))/256;
     
      //0<=r,g,b<256Ǥꡢ
      //XColorγʬͤ0-65535Ǥä
      //65536/256=256
/*
      xcolors[i].red  =(paletteOfNow[0][i+startColorNumber].r << 8)*contrast/256;
      xcolors[i].green=(paletteOfNow[0][i+startColorNumber].g << 8)*contrast/256;
      xcolors[i].blue =(paletteOfNow[0][i+startColorNumber].b << 8)*contrast/256;
*/
      xcolors[i].red  =paletteOfNow[0][i+startColorNumber].r*contrast;
      xcolors[i].green=paletteOfNow[0][i+startColorNumber].g*contrast;
      xcolors[i].blue =paletteOfNow[0][i+startColorNumber].b*contrast;
#endif
      //Ȥ餬Τʬʤ     
      xcolors[i].red  =(paletteOfNow[0][i+startColorNumber].r*(256-ratio)+
			paletteOfNow[1][i+startColorNumber].r*ratio)
	*contrast/256;
      xcolors[i].green=(paletteOfNow[0][i+startColorNumber].g*(256-ratio)+
			paletteOfNow[1][i+startColorNumber].g*ratio)
	*contrast/256;
      xcolors[i].blue =(paletteOfNow[0][i+startColorNumber].b*(256-ratio)+
			paletteOfNow[1][i+startColorNumber].b*ratio)
	*contrast/256;
    }
  
  XStoreColors (display,colormap,xcolors,numberOfColors);
}
