/* 
        MmsWindow.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include "MmsConst.h"
#include "MmsWindow.h"

MmsWindow::MmsWindow (Display* mmsDisplay,int mmsScreen,
		      Visual* mmsVisual,GC mmsGc,int mmsDepth,
		      Window mmsWindow,
		      unsigned long mmsPalette2Pixel[NUM_OF_COLORS],
		      XMMS_OPTION* mmsXmmsOption):
  display (mmsDisplay),screen (mmsScreen),
  visual (mmsVisual),gc (mmsGc),depth (mmsDepth),
  window (mmsWindow),
  ximageOf2x0LineMode (NULL),imageDataOf2x0LineMode (NULL),
  xmmsOption (mmsXmmsOption)
{
  for (int i=0;i<NUM_OF_COLORS;i++)
    palette2Pixel[i]=mmsPalette2Pixel[i];
  
  for (int i=0;i<NUM_OF_WINDOW;i++)
    virtualWindow[i].resetVariable ();

  graphicMode=GM640x480;
  windowLeft=0;
  windowTop=0;
  windowWidth=WINDOW_SIZE_X;
  windowHeight=WINDOW_SIZE_Y;
  
  //̾ν
  int imageSizeX=WINDOW_SIZE_X;
  int imageSizeY=WINDOW_SIZE_Y;
  if (xmmsOption->isShowVirtualVram)
    {//ɽwindowvirtual vramƤɽ롣
      //Τν
      imageSizeX=VIRTUAL_VRAM_SIZE_X;
      imageSizeY=VIRTUAL_VRAM_SIZE_Y;
      XSizeHints xSizeHint;
      xSizeHint.flags=PMinSize|PMaxSize;
      xSizeHint.max_width=xSizeHint.min_width=VIRTUAL_VRAM_SIZE_X;
      xSizeHint.max_height=xSizeHint.min_height=VIRTUAL_VRAM_SIZE_Y;
      XSetWMNormalHints (display,window,&xSizeHint);
      XResizeWindow (display,window,VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y);
      XFlush (display);
    }

#ifdef MITSHM
  if (xmmsOption->isUseMITSHM)
    ximage=new MaslXShmImage (display,visual,depth,imageSizeX,imageSizeY);
  else
#endif //MITSHM
    ximage=new MaslXNormalImage (display,visual,depth,imageSizeX,imageSizeY);

  imageData=ximage->getImagePointer ();
      
  ximageOfVirtualVram=NULL;
  imageDataOfVirtualVram=NULL;
  if (xmmsOption->isShowVram)
    {
      windowOfVirtualVram=
	XCreateSimpleWindow (display,RootWindow (display,screen),
			     0,0,VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y,0,
			     BlackPixel (display,screen),
			     WhitePixel (display,screen));
      XSelectInput (display,windowOfVirtualVram,ExposureMask);
      XMapWindow (display,windowOfVirtualVram);
      XFlush (display);
      XEvent event;
      do
	{//̤mapޤԤ
	  XNextEvent (display,&event);
	}while (event.xexpose.count!=0);

#ifdef MITSHM
      if (xmmsOption->isUseMITSHM)
	{
	  ximageOfVirtualVram=new MaslXShmImage (display,visual,8,
						 VIRTUAL_VRAM_SIZE_X,
						 VIRTUAL_VRAM_SIZE_Y);
	}
      else
#endif //MITSHM
	{
	  ximageOfVirtualVram=new MaslXNormalImage (display,visual,8,
						    VIRTUAL_VRAM_SIZE_X,
						    VIRTUAL_VRAM_SIZE_Y);
	}
      
      imageDataOfVirtualVram=ximageOfVirtualVram->getImagePointer ();
    }
}

MmsWindow::~MmsWindow ()
{
  delete ximage;
  delete ximageOfVirtualVram;
  delete ximageOf2x0LineMode;
}

void MmsWindow::setGraphicMode (GraphicMode MmsGraphicMode)
{
  graphicMode=MmsGraphicMode;
  //ximagewindowΤɤΰ֤ˤɤ礭ɽ뤫ꤹ롣
  switch (graphicMode)
    {//礭
    case GM320x200:
      if (xmmsOption->isReduction)
	{
	  windowWidth=320;
	  windowHeight=200;
	}
      else
	{
	  windowWidth=320*2;
	  windowHeight=200*2;
	}
      break;
    case GM320x240:
      if (xmmsOption->isReduction)
	{
	  windowWidth=320;
	  windowHeight=240;
	}
      else
	{
	  windowWidth=320*2;
	  windowHeight=240*2;
	}
      break;
    case GM640x400: 
      windowWidth=640;
      windowHeight=400;
      break;
    case GM640x480: 
      windowWidth=640;
      windowHeight=480;
      break;
    default:
      break;//do nothing;
    }
  //window˲ɽͤ˰֤ꡣ
  windowLeft=(WINDOW_SIZE_X-windowWidth)/2;
  windowTop=(WINDOW_SIZE_Y-windowHeight)/2;

  XClearWindow (display,window);
  memset (imageData,0,WINDOW_SIZE_X*WINDOW_SIZE_Y*sizeof (char));
/*
  if (imageDataOf2x0LineMode!=NULL)
    memset (imageDataOf2x0LineMode,0,WINDOW_SIZE_X*WINDOW_SIZE_Y);
*/
  updateWindow ();
}

void MmsWindow::setWindowSize (int x1,int y1,int x2,int y2,int n=0)
{
  virtualWindow[n].vramX=x1;
  virtualWindow[n].vramY=y1;
  virtualWindow[n].width=x2;
  virtualWindow[n].height=y2;
}

void MmsWindow::moveWindow (int x,int y,int n=0)
{
  virtualWindow[n].virtualVramX=x;
  virtualWindow[n].virtualVramY=y;
}

void MmsWindow::updateWindow (const unsigned char* const mmsImageData)
  //̤κmethod
{
  if (xmmsOption->isTraceMode)
    {//////trace modeäΤǤν
      for (;;)
	{
	  XEvent event;
	  XNextEvent (display,&event);
	  if (event.type!=KeyPress && event.type!=ButtonPress)
	    {
	      putImage ();
	      continue;
	    }
	      
	  //trace modeλreturntrace modeȴ
	  if(
	     (event.type==KeyPress && 
	      XKeycodeToKeysym (display,event.xkey.keycode,0)==XK_Return)||
	     (event.type==ButtonPress && event.xbutton.button==2))
	    xmmsOption->isTraceMode=False;
	  break;
	}
    }
  putImage (mmsImageData);//ɽ
}

void MmsWindow::putImage ()
{//////////////windowɽ
  if (xmmsOption->isShowVirtualVram)
    {//ɽwindowvirtual vramƤɽ롣
      ximage->XPutImage (window,gc,0,0,0,0,
			 VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y);

      if (xmmsOption->isShowVirtualWindowFrame)
	{//virtual windowȤ
	  drawVirtualWindowFrame ();
	}
      return;
    }

  switch (graphicMode)
    {
    case GM320x200:
      putImage320x200 ();
      break;
    case GM320x240:
      putImage320x240 ();
      break;
    case GM640x400: 
      putImage640x400 ();
      break;
    case GM640x480: 
      putImage640x480 ();
      break;
    default:
      break;//do nothing;
    }

  if (xmmsOption->isShowVirtualWindowFrame)
    {//virtual windowȤ
      drawVirtualWindowFrame ();
    }
}

void MmsWindow::putImage (const unsigned char* const mmsImageData)
{
  //virtual vramɽѤwindowvirtual vramƤɽ롣
  if (xmmsOption->isShowVram)
    putImageOfVirtualWindow (mmsImageData);

  if (xmmsOption->isShowVirtualVram)
    {//ɽwindowvirtual vramƤɽ롣
      if (xmmsOption->isPrivateColormapCreated)
	{//private colormapѤƤΤǡpalette==pixel value
	  //ʤΤǤΤޤͤcopyɤ
	  memcpy (imageData,mmsImageData,VIRTUAL_VRAM_LENGTH);
	}
      else
	{//common colormapѤƤΤǡpaletteͤ
	  //pixel valueѴɬפͭ롣
	  for (int i=0;i<VIRTUAL_VRAM_LENGTH;i++)
	    {
	      imageData[i]=palette2Pixel[mmsImageData[i]];
	    }
	}
      putImage ();
      return;
    }
  
  /////////////dataž
  for (int i=0;i<NUM_OF_WINDOW;i++)
    {
      if (virtualWindow[i].width==0 || virtualWindow[i].height==0)
	continue;//windowĤƤ褷ʤ
      
      //ޤdataΤɤˤʤ뤫offset׻Ƥ
      int vramOffset=virtualWindow[i].vramX+
	virtualWindow[i].vramY*WINDOW_SIZE_X;
      int virtualVramOffset=virtualWindow[i].virtualVramX+
	virtualWindow[i].virtualVramY*VIRTUAL_VRAM_SIZE_X;
      if (xmmsOption->isPrivateColormapCreated)
	{//private colormapѤƤΤǡpalette==pixel value
	  //ʤΤǤΤޤͤcopyɤ
	  for (int y=0;y<virtualWindow[i].height;y++)
	    {
	      memcpy (imageData+vramOffset+y*WINDOW_SIZE_X,
		      mmsImageData+virtualVramOffset+y*VIRTUAL_VRAM_SIZE_X,
		      virtualWindow[i].width);
	    }
	}
      else
	{//common colormapѤƤΤǡpaletteͤ
	  //pixel valueѴɬפͭ롣
	  for (int y=0;y<virtualWindow[i].height;y++)
	    {
	      for (int x=0;x<virtualWindow[i].width;x++)
		{
		  imageData[vramOffset+x+y*WINDOW_SIZE_X]=
		    palette2Pixel
		    [mmsImageData[virtualVramOffset+x+y*VIRTUAL_VRAM_SIZE_X]];
		}
	    }
	}

    }
  putImage ();
}

void MmsWindow::putImage320x200 ()
{
  if (xmmsOption->isReduction)
    {//򤻤window
      mmsXPutImage (ximage);
      return;
    }

  if (ximageOf2x0LineMode==NULL)
    allocXimageOf2x0LineMode ();//ƸƤФ줿ΤǡѴѤXImageݤ
  
  //320x200line modeʤΤǺ320x200640x400˳
  for (int y=0;y<200;y++)
    {
      for (int x=0;x<320;x++)
	{
	  imageDataOf2x0LineMode[x*2+y*2*WINDOW_SIZE_X]=
	    imageData[x+y*WINDOW_SIZE_X];
	  imageDataOf2x0LineMode[x*2+1+y*2*WINDOW_SIZE_X]=
	    imageData[x+y*WINDOW_SIZE_X];
	}
      memcpy (imageDataOf2x0LineMode+(y*2+1)*WINDOW_SIZE_X,
	      imageDataOf2x0LineMode+(y*2)*WINDOW_SIZE_X,
	      WINDOW_SIZE_X);
    }
  ///window
  mmsXPutImage (ximageOf2x0LineMode);
}

void MmsWindow::putImage640x400 ()
{
  ////Ѵɬ̵

  ///window
  mmsXPutImage (ximage);
}

void MmsWindow::putImage320x240 ()
{
  if (xmmsOption->isReduction)
    {//򤻤window
      mmsXPutImage (ximage);
      return;
    }

  if (ximageOf2x0LineMode==NULL)
    allocXimageOf2x0LineMode ();//ƸƤФ줿ΤǡѴѤXImageݤ

  ////320x240modeʤΤǺ320x240640x480˳
  for (int y=0;y<240;y++)
    {
      for (int x=0;x<320;x++)
	{
	  imageDataOf2x0LineMode[x*2+y*2*WINDOW_SIZE_X]=
	    imageData[x+y*WINDOW_SIZE_X];
	  imageDataOf2x0LineMode[x*2+1+y*2*WINDOW_SIZE_X]=
	    imageData[x+y*WINDOW_SIZE_X];
	}
      memcpy (imageDataOf2x0LineMode+(y*2+1)*WINDOW_SIZE_X,
	      imageDataOf2x0LineMode+(y*2)*WINDOW_SIZE_X,
	      WINDOW_SIZE_X);
    }

  ///window
  mmsXPutImage (ximageOf2x0LineMode);
}

void MmsWindow::putImage640x480 ()
{
  ////Ѵɬפ̵

  ///window
  mmsXPutImage (ximage);
}

void MmsWindow::allocXimageOf2x0LineMode ()
{
#ifdef MITSHM
  if (xmmsOption->isUseMITSHM)
    {
      ximageOf2x0LineMode=new MaslXShmImage (display,visual,8,
					     WINDOW_SIZE_X,WINDOW_SIZE_Y);
    }
  else
#endif //MITSHM
    {
      ximageOf2x0LineMode=new MaslXNormalImage (display,visual,8,
						WINDOW_SIZE_X,WINDOW_SIZE_Y);
    }
  
  imageDataOf2x0LineMode=ximageOf2x0LineMode->getImagePointer ();
}

void MmsWindow::putImageOfVirtualWindow
(const unsigned char* const mmsImageData)
{
  if (ximageOfVirtualVram==NULL)
    return;
  
  if (xmmsOption->isPrivateColormapCreated)
    {//private colormapѤƤΤǡpalette==pixel value
      //ʤΤǤΤޤͤcopyɤ
      memcpy (imageDataOfVirtualVram,mmsImageData,VIRTUAL_VRAM_LENGTH);
    }
  else
    {//common colormapѤƤΤǡpaletteͤ
      //pixel valueѴɬפͭ롣
      for (int i=0;i<VIRTUAL_VRAM_LENGTH;i++)
	imageDataOfVirtualVram[i]=palette2Pixel[mmsImageData[i]];
    }
  ximageOfVirtualVram->XPutImage (windowOfVirtualVram,gc,0,0,0,0,
				  VIRTUAL_VRAM_SIZE_X,VIRTUAL_VRAM_SIZE_Y);
}

void MmsWindow::drawVirtualWindowFrame ()
{
  GC lineGc=XCreateGC (display,window,0,0);
  //XSetLineAttributes (display,lineGc,1,LineSolid,CapButt,JoinMiter);
  XSetLineAttributes (display,lineGc,1,LineOnOffDash,CapButt,JoinMiter);
  //XSetLineAttributes (display,lineGc,1,LineSolid,CapButt,JoinMiter);
  static XGCValues gv;
  gv.dash_offset=(gv.dash_offset+1)%4;
  XChangeGC (display,lineGc,GCDashOffset,&gv);
  XSetForeground (display,lineGc,0xffffffff);
  XSetBackground (display,lineGc,0);
  XSetFunction (display,lineGc,GXxor);
#if 0
  XSetPlaneMask(display,lineGc,
                planeMask[0]|planeMask[1]|planeMask[2]|planeMask[3]|
                planeMask[4]|planeMask[5]|planeMask[6]|planeMask[7]);
#endif

  XRectangle rectangles[NUM_OF_WINDOW];
  
  if (!xmmsOption->isShowVirtualVram)
    {
      int magnify=1;
      if ((graphicMode==GM320x200 || graphicMode==GM320x240) &&
	  !xmmsOption->isReduction)
	{//2ܤ˳礷ƤΤǡʬ礹롣
	  magnify=2;
	}

      for (int i=0;i<NUM_OF_WINDOW;i++)
	{
	  rectangles[i].x=virtualWindow[i].vramX*magnify+windowLeft;
	  rectangles[i].y=virtualWindow[i].vramY*magnify+windowTop;
	  rectangles[i].width=virtualWindow[i].width*magnify;
	  rectangles[i].height=virtualWindow[i].height*magnify;
	}
    }
  else
    {
      for (int i=0;i<NUM_OF_WINDOW;i++)
	{
	  rectangles[i].x=virtualWindow[i].virtualVramX;
	  rectangles[i].y=virtualWindow[i].virtualVramY;
	  rectangles[i].width=virtualWindow[i].width;
	  rectangles[i].height=virtualWindow[i].height;
	}
    }
  XDrawRectangles (display,window,lineGc,rectangles,NUM_OF_WINDOW);
  
  if (xmmsOption->isShowVram)
    {
      for (int i=0;i<NUM_OF_WINDOW;i++)
	{
	  rectangles[i].x=virtualWindow[i].virtualVramX;
	  rectangles[i].y=virtualWindow[i].virtualVramY;
	  rectangles[i].width=virtualWindow[i].width;
	  rectangles[i].height=virtualWindow[i].height;
	}
      XDrawRectangles (display,windowOfVirtualVram,lineGc,
		       rectangles,NUM_OF_WINDOW);
    }
  
  XFreeGC (display,lineGc);
}
