/* 
        NakView.h

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include "MaslInputStream.h"
#include "MmsConst.h"
#include "Mms.h"
#include "MmsWindow.h"
#include "Nak.h"
#include "MmsPalette.h"

#ifndef nak_view_h
#define nak_view_h
class NakView
{
private:
  const char* const fileName;
  XMMS_OPTION xmmsOption;

  /////////////////////////////////////////////////////////////X$B4X78(B
  Display* display;//$BI=<($9$k(Bdisplay
  int screen;//screen$BHV9f(B
  Visual* visual;//visual
  int depth;//depth of color
  Window window;//window
  Colormap colormap;//$B@8@.$9$k(Bcolor map
  GC gc;//graphic context
  unsigned long basePixel;
  unsigned long planeMask[DEPTH_OF_NAK];
  unsigned long palette2Pixel [NUM_OF_COLORS];
  //=palette$BCM$+$i(Bpixel$BCM$r5a$a$k0Y$NJ*(B
  MmsWindow* mmsWindow;
  unsigned char virtualVram[VIRTUAL_VRAM_LENGTH];


  //void prepareXServer ();//X server$B$K@\B3$7!"B>$N(Bclass$B$N=`Hw$r$9$k!#(B
  void allocColors ();//X$B$N?'$N3NJ]$H$=$l$K4XO"$7$?=i4|2=$r9T$J$&(B
  
  ////////////////////////////////////////////////$B4^$`(Bdata$B$N>pJs(B
  Nak* pNak[MAXNAK];//$B2hA|(Bobject
  int numberOfNak;//$B2hA|(Bdata$B$N?t(B
  MmsPalette* pMmsPalette[MAXPAL];//palette object
  int numberOfMmsPalette;//palette$B$N?t(B

  int nNak;//$B0lHV:G8e$KE83+$7$?(Bnak$B$NHV9f(B
  int nPalette;//$B8=:_$N(Bpalette$BHV9f(B

  Bool loadNak (const char* const);

public:
  NakView (const char* const nakFileName,
	   Display* nakDisplay,XMMS_OPTION nakXmmsOption);
  ~NakView ();
  void addNak (const char* const addedNakFileName)
    {
      (void)loadNak (addedNakFileName);
    };
  int getNumberOfNak () const {return numberOfNak;};
  int putImage (const int n);
  int prevImage ()
    {
      nNak--;
      return putImage (nNak);
    };
  int nextImage ()
    {
      nNak++;
      return putImage (nNak);
    };
  void updateWindow () {(void) putImage (nNak);};
  int getNumberOfPalette () const {return numberOfMmsPalette;};
  int setPalette (const int n);
  int prevPalette ()
    {
      nPalette--;
      return setPalette (nPalette);
    };
  int nextPalette ()
    {
      nPalette++;
      return setPalette (nPalette);
    };
  void clearWindow ();
};
#endif//nak_view_h
