/* 
        audio.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <iostream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "const.h"

#ifndef audio_h
#define audio_h

#ifndef NOAUDIO
# if defined OPEN_SOUND_SYSTEM
#  include <sys/soundcard.h>
#  define SOUND_DEVICE "/dev/dsp"
//#define SOUND_DEVICE "/dev/audio"
# elif defined sunos4
#  include <sun/audioio.h>
#  define SOUND_DEVICE "/dev/audio"
# elif defined solaris
#  include <sys/audioio.h>
#  define SOUND_DEVICE "/dev/audio"
# endif
#endif


class Audio
{
  //variables
private:
  static int audio;//file descripter
  static int sampleRate;//=DEFAULT_SAMPLE_RATE;
  static Bool isDeviceOpened;//=False;//deviceopenƤ뤫
  //int bit;//sound bit
  //int rate;//sampling rate
  static Bool isAudioDisabled;//=False;//=True:audio̵,=False:audioͭ
  
public:  
  //methods
private:
  static void printErrorDeviceIsNotOpened ();
public:
  static Bool openAudioDevice ();
  static int closeAudioDevice ();
  static Bool initializeAudioDevice (const int rate);
  static void play (const unsigned char* const pcmData,int size);
  static void resetAudioDevice ();
  static Bool setRate (const long rate);
  static int getNoBlockingSize ();
  static int getFragmentSize ();
  static int getSampleRate ();
  static void sync ();
  static void post ();

  //ʲaudioͭˤ뤫̵ˤ뤫Ǥ
  //deviceopen(openAudioDevice ()Ƥ)ˤѹʤǲ
  //openAudioDevice ()ƤϸƤФʤǲ
  //Ǥʤdevicecloseʤʤޤ
  //⤷ѹϰödevicecloseƤ
  //(closeAudioDevice ()ƤǤ)ˤƲ
  static void enableAudio ();
  static void disableAudio ();
  static Bool isAudioEnabled ();
};

#endif audio_h
