/* 
        nakview.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#include "NakView.h"

main (int argc,char** argv)
{
  if (argc<2)
    {
      cerr << "Usage:" << argv[0] << " filename.nak [morefiles.nak...]"
	   << endl;
      exit (-1);
    }

  const char* const fileName=argv[1];
  XMMS_OPTION xmmsOption=XMMS_OPTION ();

  static String fallbackResources[]=
  {
    NULL,
  };
  
  XtAppContext appContext;
  Widget topLevel;
  XtToolkitInitialize ();
  topLevel=XtVaAppInitialize (&appContext,APP_CLASS_NAME,NULL,ZERO,
                              &argc,argv,fallbackResources,
                              XtNwidth, VIRTUAL_VRAM_SIZE_X,
                              XtNheight,VIRTUAL_VRAM_SIZE_Y,NULL);
  Display* display=XtDisplay (topLevel);
  if (display==NULL)
    {//X server$B$H$N@\B3$,=PMh$J$+$C$?(B
      cerr << "Error Can not connect X server." << endl;
      exit (-1);
    }
  ////////////////////////////////////////////file$B$N(Bload
  NakView nak(fileName,display,xmmsOption);
  for (int i=2;i<argc;i++)
    nak.addNak (argv[i]);
  
  ///////////////////////////////////////////palette$B$N@_Dj!#(B
  if (nak.getNumberOfPalette ()>0)
    nak.setPalette (0);

  ///////////////////////////////////////////$B2hA|$NI=<((B
  for (int i=0;i<nak.getNumberOfNak ();i++)
    {
      nak.putImage (i);
      for (;;)
	{
	  XEvent event;
	  XNextEvent (display,&event);
	  if (event.type==ButtonPress)
	    {
	      switch (event.xbutton.button)
		{
		case 1:
		  cout << nak.prevPalette () << "-th palette " << endl;
		  break;
		case 2:
		  i=nak.prevImage ();
		  cout << i << "-th image" << endl;
		  break;
		case 3:
		  cout << nak.nextPalette () << "-th palette " << endl;
		  break;
		default:
		  break;//do nothing
		}
	    }

	  if (event.type==KeyPress)
	    break;

	  nak.updateWindow ();
	}
    }
}
